-- =============================================================================
-- Sistema    : Manufatura Comissaria
-- Programador: Leonardo Monteiro
-- Data       : 06/07/2004
-- =============================================================================
-- Descrio  : Rotina para calcular o tempo de preparo da receita.
-- =============================================================================
-- @C:\WIN_V4\SQL\END_CONV\ORACLE\2920_MACSTPO_Calc_TempoProd_Voo.SQL
-- =============================================================================
CREATE OR REPLACE PROCEDURE CALC_TEMPOPREP_REC(
P_CDFILIAL    IN  FILIAL   .CDFILIAL    %TYPE,
P_CDRECEITA   IN  PRODUTO  .CDPRODUTO   %TYPE,
P_QTHRPREPREC OUT ETAFABRIC.QTHRETFABRIC%TYPE)
AS
V_IDTIPORECNUT TRABNUTRIREC.IDTIPORECNUT%TYPE;
V_QTRENDREC    RENDPADRAO  .QTRENDRECPAD%TYPE;
V_QTAPROREC    RENDPADRAO  .QTAPRORECPAD%TYPE;

V_CDRECEITA    RECEITA     .CDRECEITA   %TYPE;
V_QTRENDSUBREC SUBRECEITA  .QTRENDSUBREC%TYPE;
V_QTHRPREPREC  ETAFABRIC   .QTHRETFABRIC%TYPE;
V_QTHRPRODSREC ETAFABRIC   .QTHRETFABRIC%TYPE;
V_QTHRMAIORREC ETAFABRIC   .QTHRETFABRIC%TYPE;

CURSOR C_SRECP IS
SELECT CDSUBREC,QTRENDSUBREC
FROM SUBRECEITA
WHERE (CDRECEITA = P_CDRECEITA);

CURSOR C_SRECL IS
SELECT CDSUBRECLOC,QTRENDSUBLOC
FROM SUBRECLOC
WHERE (CDFILIAL  = P_CDFILIAL ) AND
      (CDRECEITA = P_CDRECEITA);

BEGIN
	/* Verifica se j foi calculado o tempo de preparo para a receita. */
	SELECT MAX(QTHRPREPREC)
   INTO V_QTHRPREPREC
   FROM TEMPOPREPREC
   WHERE (CDFILIAL  = P_CDFILIAL ) AND
         (CDRECEITA = P_CDRECEITA);

   IF V_QTHRPREPREC IS NULL THEN
      RETORNA_RENDREC(P_CDFILIAL,P_CDRECEITA,V_IDTIPORECNUT,
                      V_QTRENDREC,V_QTAPROREC);

      IF V_IDTIPORECNUT IS NOT NULL THEN

         IF V_IDTIPORECNUT = '1' THEN
            OPEN C_SRECP;
         ELSIF V_IDTIPORECNUT = '2' THEN
            OPEN C_SRECL;
         END IF;

         V_QTHRMAIORREC := 0;
         LOOP
            IF V_IDTIPORECNUT = '1' THEN
               FETCH C_SRECP
               INTO V_CDRECEITA,V_QTRENDSUBREC;
               EXIT WHEN C_SRECP%NOTFOUND;
            ELSIF V_IDTIPORECNUT = '2' THEN
               FETCH C_SRECL
               INTO V_CDRECEITA,V_QTRENDSUBREC;
               EXIT WHEN C_SRECL%NOTFOUND;
            END IF;

            /* Calcula o tempo para preparar a composio da receita*/
            CALC_TEMPOPREP_REC(P_CDFILIAL,V_CDRECEITA,V_QTHRPRODSREC);

            /* Soma o tempo de preparo da composio da receita com o tempo da receita */
            SELECT NVL(SUM(TE.QTHRETFABRPR),0)+V_QTHRPRODSREC
            INTO V_QTHRPRODSREC
            FROM TEMPOETAFABR TE, PROCFABRICA PF
            WHERE (PF.CDFILIAL     = P_CDFILIAL     ) AND
                  (PF.CDPRODUTO    = V_CDRECEITA    ) AND
                  (PF.IDPROFABPADR = 'S'            ) AND
                  (TE.CDFILIAL     = PF.CDFILIAL    ) AND
                  (TE.CDPRODUTO    = PF.CDPRODUTO   ) AND
                  (TE.CDPROCFABRIC = PF.CDPROCFABRIC) AND
                  (V_QTRENDSUBREC BETWEEN TE.VRINIQTFABPR AND TE.VRFINQTFABPR);

            IF V_QTHRMAIORREC <  V_QTHRPRODSREC THEN
               V_QTHRMAIORREC := V_QTHRPRODSREC;
            END IF;

         END LOOP;
         IF V_IDTIPORECNUT = '1' THEN
            CLOSE C_SRECP;
         ELSIF V_IDTIPORECNUT = '2' THEN
            CLOSE C_SRECL;
         END IF;

         V_QTHRPREPREC := V_QTHRMAIORREC;

         INSERT INTO TEMPOPREPREC
         (CDFILIAL,CDRECEITA,QTHRPREPREC)
         VALUES
         (P_CDFILIAL,P_CDRECEITA,V_QTHRPREPREC);

      END IF;
   END IF;
   P_QTHRPREPREC := NVL(V_QTHRPREPREC,0);
END;
/
