function LSPrivacyPolicyController(LSUtilities, LSSettingsService, ScreenService, templateManager, MessageService, ApplicationContext, ZhFilterPreferences, LSPrivacyPolicyService) {
    var FORM_TEMPLATE = 'widget/form.html';
    var FORM_VIEW_TEMPLATE = 'widget/form-view.html';
    var divField = '';
    var self = this;

    var getContainer = function() {
        return templateManager.container;
    };

    var getWidgetPrivacyPolicy = function() {
        return getContainer().getWidget('PRIVACY_POLICY');
    };

    var getActionDeleteWidgetPrivacyPolicy = function () {
        return getWidgetPrivacyPolicy().getAction('DELETE');
    };

    this.privacyPolicyContainerAfterInit = function() {
        var privacyPolicyWidget = getWidgetPrivacyPolicy();
        privacyPolicyWidget.activate();
    };

    this.privacyPolicyWidgetOnEnter = function () {
        Util.doAsync(function () {
            LSPrivacyPolicyService.findPrivacyPolicy().then(function (response) {
                var pdfUrl = response.pdfPath;
                var htmlPDF = "<iframe id='pdfPrivacyPolicyUpload' src = "+ pdfUrl + "#page=1&zoom=109' width='100%' height='100%' type='application/pdf' style='margin-bottom: 40px'></iframe>";
                var fieldSelector = $("#PDF");
                divField = fieldSelector.parent()[0];
                fieldSelector.parent()[0].innerHTML = htmlPDF;
                getActionDeleteWidgetPrivacyPolicy().isVisible = !response.documentDefault;
                getWidgetPrivacyPolicy().edit();
                templateManager.updateTemplate();
            }).catch(LSUtilities.defaultError);
        }, 200);
    };

    this.privacyPolicyActionEventDelete = function() {
        MessageService.showCustomDialogByCode('login#ALE_REMOVE_PRIVACY_POLICY', null, {
            type: 'confirmation',
            actions: [{
                label: ScreenService.i18n("Sim"),
                code: function () {
                    var widget = getWidgetPrivacyPolicy();
                    LSPrivacyPolicyService.removePrivacyPolicy().then(function(response) {
                        $('#pdfPrivacyPolicyUpload').attr('src', response.pdfPath);
                        getActionDeleteWidgetPrivacyPolicy().isVisible = !response.documentDefault;
                        MessageService.successNotificationByCode('login#SUC_REMOVE_PRIVACY_POLICY');
                    }).catch(LSUtilities.defaultError);
                }
            }, {
                label: ScreenService.i18n("Não"),
                code: function () {}
            }]
        });
    };

    this.privacyPolicyActionEventEdit = function () {
        var activeDirectoryWidget = getWidgetPrivacyPolicy();
        activeDirectoryWidget.edit();
    };

    this.privacyPolicyActionEventSave = function () {
        var widget = getWidgetPrivacyPolicy();
        if(widget.isValid()) {
            LSPrivacyPolicyService.uploadPrivacyPolicy(widget.currentRow).then(function(response) {
                getActionDeleteWidgetPrivacyPolicy().isVisible = !response.documentDefault;
                widget.currentRow.UPLOAD_PRIVACY_POLICY = [];
                widget.getField('UPLOAD_PRIVACY_POLICY').fileList = widget.currentRow.UPLOAD_PRIVACY_POLICY;
                $('#pdfPrivacyPolicyUpload').attr('src', response.pdfPath);
                templateManager.updateTemplate();
                MessageService.successNotificationByCode('login#SUC_SAVE_PRIVACY_POLICY');
            }).catch(LSUtilities.defaultError);
        }
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('LSPrivacyPolicyController', LSPrivacyPolicyController);
});