function LSPrivacyPolicyService(LSUtilities) {

    this.uploadPrivacyPolicy = function(row){
        return LSUtilities.dataSource.setDataSource('login#/uploadPrivacyPolicy', [row]).then(function(data){
            return data.dataset.uploadPrivacyPolicy[0];
        });
    };

    this.findPrivacyPolicy = function () {
        return LSUtilities.dataSource.getDataSource('login#/findPrivacyPolicy', []).then(function(data){
            return data.dataset.findPrivacyPolicy[0];
        });
    };

    this.findPrivacyPolicyByAuthentication = function (user) {
        var filter = [
            {
                name: "USER",
                operator: "=",
                value: user
            }
        ];
        return LSUtilities.dataSource.getDataSource('login#/findPrivacyPolicyByAuthentication', filter).then(function(data){
            return data.dataset.findPrivacyPolicyByAuthentication[0];
        });
    };

    this.removePrivacyPolicy = function () {
        return LSUtilities.dataSource.getDataSource('login#/removePrivacyPolicy', []).then(function(data){
            return data.dataset.removePrivacyPolicy[0];
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('LSPrivacyPolicyService', LSPrivacyPolicyService);
});